#ifndef EFL_GFX_VIEW_EO_HH
#define EFL_GFX_VIEW_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx_view.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace gfx { 
struct View;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::View> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace gfx { 
struct View {
   ::efl::eolian::return_traits<void>::type view_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type view_size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_VIEW_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::gfx::View() const;
   operator ::efl::gfx::View&();
   operator ::efl::gfx::View const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<View> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<View const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace gfx { 
struct View : ::efl::eo::concrete
{
   explicit View( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit View(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   View(View const& other) = default;
   View(View&& other) = default;
   View& operator=(View const& other) = default;
   View& operator=(View&& other) = default;
   View()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   View( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> View(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type view_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type view_size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_VIEW_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<View> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<View const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(View) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<View>::value, "");
} } 
#include "efl_gfx_view.eo.impl.hh"
#endif
